"Status Line" by David Kinder

Include Basic Screen Effects by Emily Short.
Include Flexible Windows by Jon Ingold.
Include Glulx Status Window Control by Erik Temple.

Testing Area is a room.

The status-depth is a number variable. The status-depth is 3.

Understand "status [number]" as changing status.
Changing status is an action applying to a number.
Carry out changing status:
	say "The status window depth is now set to [the number understood].";
	now the status-depth is the number understood.

Understand "toggle" as toggling the status window.
Toggling the status window is an action applying to nothing.
Carry out toggling the status window:
	if the status window is already open:
		say "The status window is now invisible.";
		close the status window;
	otherwise:
		say "The status window is now visible.";
		open the status window.

[ This DrawStatusLine() comes from the standard rules, but has had the initial call to set the status line depth to 1 removed. ]
Include (-
[ DrawStatusLine width posb;
	@push say__p; @push say__pc;
	BeginActivity(CONSTRUCTING_STATUS_LINE_ACT);
	VM_MoveCursorInStatusLine(1, 1); 
	if (statuswin_current) {
		width = VM_ScreenWidth(); posb = width-15;
		spaces width;
		ClearParagraphing();
		if (ForActivity(CONSTRUCTING_STATUS_LINE_ACT) == false) {
			VM_MoveCursorInStatusLine(1, 2);
			switch(metaclass(left_hand_status_line)) {
				String: print (string) left_hand_status_line;
				Routine: left_hand_status_line();
			}
			VM_MoveCursorInStatusLine(1, posb);
			switch(metaclass(right_hand_status_line)) {
				String: print (string) right_hand_status_line;
				Routine: right_hand_status_line();
			}
		}
		VM_MoveCursorInStatusLine(1, 1); VM_MainWindow();
	}
	ClearParagraphing();
	EndActivity(CONSTRUCTING_STATUS_LINE_ACT);
	@pull say__pc; @pull say__p;
];
-) before "Printing.i6t".

To initialize/initialise the/-- status window:
	(- InitCustomStatusWindow(); -)

[ This is InitStatusWindow() from "Glulx Status Window Control", modified to always open the status window by splitting the root Glk window. ]
Include (-
[ InitCustomStatusWindow sty;
	if (gg_statuswin == 0) {
		statuswin_cursize = statuswin_size;
		if ( (+ status window background reversed +) ) {
			for (sty=0: sty<style_NUMSTYLES: sty++)
				glk_stylehint_set(wintype_TextGrid, sty, stylehint_ReverseColor, 1);
		}
		gg_statuswin = glk_window_open(glk_window_get_root(), statuswin_pos, statuswin_cursize, wintype_TextGrid, GG_STATUSWIN_ROCK);
	}
];
-)

Table of One Deep Status Window
left	central	right
"Punchpower: 700"	"*"	"Kickpower: Super duper"

Table of Two Deep Status Window
left	central	right
"Punchpower: 700"	"*"	"Kickpower: Super duper"
"Hp: 300/300"	"*"	"Rockingness: Rockin'"

Table of Three Deep Status Window
left	central	right
"Punchpower: 700"	"*"	"Kickpower: Super duper"
"Hp: 300/300"	"*"	"Rockingness: Rockin'"
"Wisdom: Awe inspiringly great"	"*"	"Cleanliness: Godly"

Rule for constructing the status line:
	if status-depth is:
		-- 1: fill the status bar with the table of One Deep Status Window;
		-- 2: fill the status bar with the table of Two Deep Status Window;
		-- otherwise: fill the status bar with the table of Three Deep Status Window.

The statusanchor-window is a graphics g-window.
The main-window spawns the statusanchor-window.
The statusanchor-window has back-colour g-red.
The position of the statusanchor-window is g-placeabove.
The scale method of the statusanchor-window is g-fixed-size.
The measurement of the statusanchor-window is 20.

The textmap-window is a text-buffer g-window.
The main-window spawns the textmap-window.
The position of the textmap-window is g-placeright.
The scale method of the textmap-window is g-fixed-size.
The measurement of the textmap-window is 35.

When play begins:
	now right alignment depth is 38;
	set the background of the status window to colored;
	set the background color of the status window to g-green;
	set the text color of the status window to g-white;
	open the status window;
	open up the statusanchor-window;
	open up the textmap-window.
